/**
 * 
 */
package hu.bme.mit.graph.editor.commands;

import org.eclipse.gef.commands.Command;

import hu.bme.mit.graph.model.graph.Arc;
import hu.bme.mit.graph.model.graph.Graph;
import hu.bme.mit.graph.model.graph.Node;

/**
 * @author meres
 *
 */
public class ArcCreateCommand extends Command{

	private Node source, target;
	private Arc arc;
	private Graph parent;
	
	public void setSource(Node source) {
		this.source = source;
		parent = (Graph) source.eContainer();
	}
	public void setTarget(Node target) {
		this.target = target;
	}
	public void setArc(Arc arc) {
		this.arc = arc;
	}
	@Override
	public boolean canExecute() {
		return source != null && target != null;
	}
	@Override
	public void execute() {
		arc.setSource(source);
		arc.setTarget(target);
		arc.setDescription("A" + Integer.toString(parent.getArcs().size() + 1));
		parent.getArcs().add(arc);
	}
	@Override
	public void undo() {
		arc.setSource(null);
		arc.setTarget(null);
		parent.getArcs().remove(arc);
	}
	
	
}
