/**
 * 
 */
package hu.bme.mit.graph.editor.commands;

import hu.bme.mit.graph.model.graph.Graph;
import hu.bme.mit.graph.model.graph.Node;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.commands.Command;

/**
 * @author meres
 *
 */
public class CreateNodeCommand extends Command {

	private Node node;
	private Rectangle constraint;
	private Graph parent;
	@Override
	public void execute() {
		setNodeConstraint();
		setNodeName();
		parent.getNodes().add(node);
	}
	private void setNodeName() {
		node.setDescription("N" + Integer.toString(parent.getNodes().size()+1));
		
	}
	private void setNodeConstraint() {
		if (constraint != null) {
			node.setX(constraint.x);
			node.setY(constraint.y);
			node.setWidth(constraint.width);
			node.setHeight(constraint.height);
		}
	}
	
	private static final Dimension INITIAL_NODE_DIMENSION = new Dimension(30,30);
	
	public void setNode(Node node) {
		this.node = node;
	}
	
	public void setLocation(Point location) {
		this.constraint = new Rectangle(location, INITIAL_NODE_DIMENSION);
	}
	
	public void setParent(Graph parent) {
		this.parent = parent;
	}
	@Override
	public boolean canUndo() {
		return node != null && parent.getNodes().contains(node);
	}
	@Override
	public void undo() {
		parent.getNodes().remove(node);
	}
}
