/**
 * 
 */
package hu.bme.mit.graph.editor.commands;

import hu.bme.mit.graph.model.graph.Node;

import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.commands.Command;

/**
 * @author meres
 *
 */
public class NodeMoveResizeCommand extends Command {

	private Rectangle newConstraint, oldConstraint;
	private Node node;
	public void setNewConstraint(Rectangle newConstraint) {
		this.newConstraint = newConstraint;
	}
	public void setNode(Node node) {
		this.node = node;
	}
	@Override
	public boolean canUndo() {
		return oldConstraint != null;
	}
	@Override
	public boolean canExecute() {
		return true;
	}
	@Override
	public void execute() {
		if (oldConstraint == null) {
			oldConstraint = new Rectangle(node.getX(), node.getY(), node.getWidth(), node.getHeight());
		}
		node.setX(newConstraint.x);
		node.setY(newConstraint.y);
		node.setWidth(newConstraint.width);
		node.setHeight(newConstraint.height);
	}
	@Override
	public void undo() {
		node.setX(oldConstraint.x);
		node.setY(oldConstraint.y);
		node.setWidth(oldConstraint.width);
		node.setHeight(oldConstraint.height);
	}
	
	
}
