package hu.bme.mit.graph.editor.parts;

import hu.bme.mit.graph.model.graph.Arc;
import hu.bme.mit.graph.model.graph.Graph;
import hu.bme.mit.graph.model.graph.Node;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;

public class GraphEditPartFactory implements EditPartFactory{

	@Override
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof Graph) {
			return new GraphModelEditPart((Graph) model);
		} else if (model instanceof Node) {
			return new NodeEditPart((Node) model);
		} else if (model instanceof Arc) {
			return new ArcEditPart((Arc) model);
		}
		return null;
	}

}
