/**
 * 
 */
package hu.bme.mit.graph.editor.parts;

import java.util.List;

import hu.bme.mit.graph.editor.policies.NodeSizePlaceEditPolicy;
import hu.bme.mit.graph.model.graph.Graph;
import hu.bme.mit.graph.model.graph.Node;

import org.eclipse.draw2d.FreeformLayer;
import org.eclipse.draw2d.FreeformLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.gef.DragTracker;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.editparts.AbstractEditPart;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;

/**
 * @author meres
 *
 */
public class GraphModelEditPart extends AbstractGraphicalEditPart implements Adapter{

	public GraphModelEditPart(Graph graph) {
		setModel(graph);
	}
	
	@Override
	protected List getModelChildren() {
		return ((Graph)getModel()).getNodes();
	}

	@Override
	protected IFigure createFigure() {
		FreeformLayer layer = new FreeformLayer();
		layer.setLayoutManager(new FreeformLayout());
		layer.setBorder(new LineBorder(1));
		return layer;
	}

	@Override
	protected void createEditPolicies() {
		installEditPolicy(EditPolicy.LAYOUT_ROLE, new NodeSizePlaceEditPolicy());
		
	}

	@Override
	public Notifier getTarget() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean isAdapterForType(Object type) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void notifyChanged(Notification notification) {
		int type = notification.getEventType();
		   switch (type) {
		      case Notification.ADD:
		      case Notification.ADD_MANY:
		      case Notification.REMOVE:
		      case Notification.REMOVE_MANY:
		         refreshChildren();
		         break;
		      case Notification.SET:
		         refreshVisuals();
		         break;
		   }

	}

	@Override
	public void setTarget(Notifier newTarget) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void activate() {
		if (!isActive()) ((Graph)getModel()).eAdapters().add(this);
		super.activate();
	}

	@Override
	public void deactivate() {
		if (isActive()) ((Graph)getModel()).eAdapters().remove(this);
		super.deactivate();
	}

}
