/**
 * 
 */
package hu.bme.mit.graph.editor.policies;

import hu.bme.mit.graph.editor.commands.CreateNodeCommand;
import hu.bme.mit.graph.editor.commands.NodeMoveResizeCommand;
import hu.bme.mit.graph.model.graph.Graph;
import hu.bme.mit.graph.model.graph.Node;

import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.XYLayoutEditPolicy;
import org.eclipse.gef.requests.CreateConnectionRequest;
import org.eclipse.gef.requests.CreateRequest;

/**
 * @author meres
 *
 */
public class NodeSizePlaceEditPolicy extends XYLayoutEditPolicy {

	/* (non-Javadoc)
	 * @see org.eclipse.gef.editpolicies.ConstrainedLayoutEditPolicy#createChangeConstraintCommand(org.eclipse.gef.EditPart, java.lang.Object)
	 */
	@Override
	protected Command createChangeConstraintCommand(EditPart child,
			Object constraint) {
		NodeMoveResizeCommand command = new NodeMoveResizeCommand();
		command.setNode((Node) child.getModel());
		command.setNewConstraint((Rectangle) constraint);
		return command;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.editpolicies.LayoutEditPolicy#getCreateCommand(org.eclipse.gef.requests.CreateRequest)
	 */
	@Override
	protected Command getCreateCommand(CreateRequest request) {
		if (request.getNewObjectType().equals(Node.class)) {
			CreateNodeCommand result = new CreateNodeCommand();
			result.setLocation(request.getLocation());
			result.setNode((Node) request.getNewObject());
			result.setParent((Graph) getHost().getModel());
			return result;
		}
		return null;
	}

}
