/**
 * 
 */
package hu.bme.mit.graph.editor.view;

import org.eclipse.draw2d.ChopboxAnchor;
import org.eclipse.draw2d.ConnectionAnchor;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.XYLayout;
import org.eclipse.draw2d.geometry.Rectangle;

/**
 * @author meres
 *
 */
public abstract class AbstractNodeFigure extends Figure{
	
	private Label label;
	private Shape shape;
	
	public AbstractNodeFigure() {
		setLayoutManager(new XYLayout());
		shape = getShape();
		shape.setOpaque(true);
		add(shape);
		label = new Label();
		add(label);
	}
	
	public Label getLabel() {
		return label;
	}
	
	abstract Shape getShape();

	@Override
	protected void paintFigure(Graphics graphics) {
		Rectangle r = getBounds().getCopy();
		setConstraint(shape, new Rectangle(0, 0, r.width, r.height));
		setConstraint(label, new Rectangle(0, 0, r.width, r.height));
		shape.invalidate();
		label.invalidate();
	}

	public abstract ConnectionAnchor getConnectionAnchor();
}
